#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "reduce_array4xi.py">
#<abstract4xi abstract = "provides function reduce_array4xi"/>
#<refer4xi reference = "managers.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'reduce_array4xi' ] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    import weakref
    import array
    import queue
    from traceback import format_exc
    import copyreg         
except:
    pass
   
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.managers import reduce_array
except:
    print("reduce_array4xi.py *** failed in from multiprocessing.managers import reduce_array ***")
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from forkingpickler4xi import ForkingPickler4Xi
from print4xi import print4xi
from time4xi import time4xi
#"
#/>
 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "reduce_array4xi" usage = "
#   forking.py:
#       ForkingPickler.register(array.array, reduce_array)
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def reduce_array4xi (a):
    '''
    given as a parameter ForkingPickler4Xi.register
    '''
    
    # -----------------------------------------------------------------------------------------    
    #
    # ----------------------------------------------------------------------------------------- 
          
    class2print = "reduce_array4xi"
    method2print = "reduce_array4xi"

    message2print = "{started" + "; reduce-array4xi-started: " + str(reduce_array4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
        
          
    message2print = "{passed" + "; array-passed-to-reduce-array4xi: " + str(a) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
                    
    
    # -----------------------------------------------------------------------------------------    
    #
    # ----------------------------------------------------------------------------------------- 
           
    message2print = "{passing" + "; array-typecode-passing-to-array-array-by-reduce-array4xi: " + str(a.typecode) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
        
    message2print = "{passing" + "; array-tostring-passing-to-array-array-by-reduce-array4xi: " + str(a.tostring()) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)              
        
    message2print = "{returning" + "; array-array-function-returning-by-reduce-array4xi: " + str(array.array) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
        
        
    return array.array, (a.typecode, a.tostring())
#</function4xi>


# -------------------------------------------------------------------------------------------------
# Register in module level                            
# ------------------------------------------------------------------------------------------------- 
#<register4xi registration = "
ForkingPickler4Xi.register(array.array, reduce_array4xi)
#"
#>


#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of reduce_array4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
